// Copyright (c) 2015, <your name>. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.


library orientdb_server.base;

import 'dart:async';
import 'dart:io';
import 'dart:convert';
/// Checks if you are awesome. Spoiler: you are.
class Awesome {
  bool get isAwesome => true;
}

class OrientDB_UrlParts {
  String userName;
  String password;
  String host;
  int port;

  OrientDB_UrlParts(this.userName, this.password, this.host, this.port);

  String shortToString() => "${this.host}:${this.port}";
  String longToString() => "${this.userName}:${this.password}@${this.host}:${this.port}";
}

Future<List> DatabaseList(OrientDB_UrlParts urlParts) {
  var completer = new Completer();
  List databaseList = new List();
  HttpClient client = new HttpClient();
  client.getUrl(Uri.parse("http://${urlParts.shortToString()}/listDatabases"))
  .then((request) {
    return request.close();
  }).then((response) {
    response.transform(UTF8.decoder).listen((contents) {
      Map json = JSON.decode(contents);
      for (var db in json['databases']) {
        databaseList.add(db);
      }
    });
    completer.complete(databaseList);
  });
  return completer.future;
}